;**********************************************************************
;   ASM Source Created Using BASM 6.5(c) 1998  by Kevin Diggins 
;**********************************************************************
;      File Name: SETVESA2.ASM
;  Creation Date: 12-06-2001
;  Creation Time: 00:12:06
;**********************************************************************

.286p

MaxString Equ 81 

Code Segment Byte Public
Code Ends

Data Segment Word Public
Data Ends

Stak Segment Word Stack
DW  256 DUP (?)
Stak Ends

Dummy Segment Para Public
Dummy Ends


Code Segment
Assume CS:Code,DS:Data,ES:Nothing,SS:Stak

;**********************************************************************
;Get the command line
;**********************************************************************
Push ES                                     ;Save PSP
Mov  BX,Seg Data
Mov  DS,BX
Push DS
Push DS
Mov  DI,0
Lea  BX,ES:[81h]
GetTail:
Mov  AL,ES:[BX]
Cmp  AL,13
Je   GotTail
Mov  Command$[DI],AL
Inc  DI
Inc  BX
Jmp  GetTail
GotTail:
Mov  Command$ [DI],0
Pop  DS
Pop  ES
Cld
Mov  SI,Offset Command$ + 1
Mov  DI,Offset Command$
Mov  CX,80
Rep  Movs Byte Ptr [DI],Byte Ptr ES:[SI]
Pop  ES                                     ;Restore PSP
;**********************************************************************
;                         Free Unused Memory
;**********************************************************************

Mov  BX,Seg Data
Mov  DS,BX               ;Set data segment
Mov  BX,Seg Dummy        ;End of pgm
Mov  AX,CS               ;Start of pgm
Sub  BX,AX               ;Calc pgm size
Add  BX,16               ;Paragraphs in Stack + 1
Mov  AH,4AH              ;Shrink mem
Int  21h                 ;Thru Dos
Push DS
Pop  AX                  
Mov  ES,AX               ;Set ES to DS
Mov  DefSeg,AX           ;DefSeg defaults to DS
Mov  $DataSeg,AX         ;Set $DataSeg to DS
;**********************************************************************
Call GetCursor
;**********************************************************************
;                        Translation begins
;**********************************************************************
;CMD$ = COMMAND$ 
;**********************************************************************
     Call ClrWork
     Mov  SI,Offset COMMAND$
     Mov  DI,Offset CMD$
     Call MoveStr
;**********************************************************************
;CMD$ = TRIM$ CMD$ 
;**********************************************************************
     Call ClrWork
     Mov  SI,Offset CMD$
     Call Trim$
     Call Concat_2
     Mov  DI,Offset CMD$
     Call Assign
;**********************************************************************
;MODE = VAL CMD$ 
;**********************************************************************
     Xor  AX,AX
     Mov  $Var0,AX
     Mov  DI,Offset CMD$
     Call Val
     Add  AX,$Var0
     Mov  MODE,AX
;**********************************************************************
;SETVESA MODE 
;**********************************************************************
     Mov  AX,4F02h
     Mov  BX,MODE
     OR   BX,4000h
     Int  10h
;**********************************************************************
;CLS 
;**********************************************************************
     Call Cls
     
ExitToDos:
     
     Mov  AH,4Ch
     Xor  AL,AL
     Int  21h
     
     
;************** User Defined SUBS & FUNCTIONS ***************
     
;*************  BASM Library Code Begins Here  **************
     
     
     GetCursor Proc Near
     Mov  AH,3
     Xor  BH,BH
     Int  10h
     Xor  AX,AX
     Mov  AL,DL
     Inc  AL
     Mov  $Xcur,AX
     Mov  AL,DH
     Inc  AL
     Mov  $Ycur,AX
     Ret
     GetCursor Endp
     
     
     
     
     MoveStr Proc Near
     Cld
MoveStr1:
     Lodsb
     Stosb
     Or  AL,AL
     Jnz MoveStr1
     Ret
     MoveStr Endp
     
     
     
     
     Len Proc Near
     Push CX
     Push SI
     Push DI
     Mov  DI,SI
     Xor  AL,AL
     Mov  CX,0ffffh
     Cld
     Repnz Scasb
     Not  CX
     Dec  CX
     Mov  AX,CX
     Pop  DI
     Pop  SI
     Pop  CX
     Ret
     Len Endp
     
     
     
     
     Concat Proc Near
     Push CX
     Push DI
     Push SI
     Push SI
     Push DI
     Pop  SI
     Call Len
     Mov  BX,AX
     Pop  SI
     Call Len
     Mov  CX,AX
     Inc  CX
     Pop  SI
     Pop  DI
     Add  DI,BX
     Cld
     Rep  Movs Byte Ptr[DI],Byte Ptr ES:[SI]
     Pop  CX
     Ret
     Concat Endp
     
     
     
     
     Concat_2 Proc Near
     Mov  SI,Offset $_1_
     Mov  DI,Offset $_0_
     Call Concat
     Ret
     Concat_2 Endp
     
     
     
     
     Val Proc Near
     Push BP
     Mov  BP,SP
     Sub  SP,2
     Xor  BX,BX
     Mov  [BP-2],BX
     Mov  SI,BX
     Mov  CX,1
Val_1:
     Mov  AX,[DI]
     Xor  AH,AH
     Cmp  AL,AH
     Je   Val_4
     Cmp  AL,48
     Jb   Val_2
     Cmp  AL,57
     Jg   Val_2
     Sub  AL,'0'
     Push AX
     Inc  SI
Val_2:
     Cmp  AL,45
     Jne Val_3
     Mov Word Ptr[BP-2],1
Val_3:
     Inc  DI
     Jmp  Val_1
Val_4:
     Cmp  SI,0
     Je   Val_5
     Pop  AX
     Mul  CX
     Add  BX,AX
     Mov  AX,CX
     Mov  CX,10
     Mul  CX
     Mov  CX,AX
     Dec  SI
     Cmp  SI,1
     Jge  Val_4
     Mov  AX,BX
     Jmp  Val_6
Val_5:
     Xor  AX,AX
Val_6:
     Cmp  Word Ptr[BP-2],1
     Jne  Val_7
     Neg  AX
Val_7:
     Mov  SP,BP
     Pop  BP
     Ret
     Val Endp
     
     
     
     
     Cls Proc Near
     Push BP
     Mov  $Xcur,1
     Mov  $Ycur,1
     Mov  AH,0Fh
     Int  10h
     Cmp  AL,3
     Jg   ClsGraphics
     Mov  AH,06
     Xor  AL,AL
     Mov  BX,$Attr
     Mov  BH,BL
     Xor  CX,CX
     Mov  DH,24
     Mov  DL,79
     Int  10h
     Xor  BX,BX
     Xor  DX,DX
     Mov  AH,02
     Int  10h
     Jmp  ClsEnd
ClsGraphics:
     Mov  BX,BgColor
     Xchg BH,BL
     Xor  CX,CX
     Mov  DL,79
     Mov  DH,43
     Mov  AX,0600h
     Int  10h
ClsEnd:
     Pop  BP
     Ret
     Cls  Endp
     
     
     
     
     Trim$ Proc Near
     Mov  DI,Offset $_2_
     Call MoveStr
     Mov  SI,Offset $_2_
     Call Ltrim$
     Mov  SI,Offset $_1_
     Mov  DI,Offset $_2_
     Call MoveStr
     Mov  SI,Offset $_2_
     Call Rtrim$
     Ret
     Trim$ Endp
     
     
     
     
     Rtrim$ Proc Near
     Mov  DI,Offset $_2_
     Call MoveStr
     Mov  SI,Offset $_2_
     Mov  DI,Offset $_1_
     Call MoveStr
     Mov  SI,Offset $_1_
     Call Len
     Mov  DI,Offset $_1_
     Mov  CX,AX
     Add  DI,AX
Rtrim1:
     Mov  BL,[DI]
     Cmp  BL,32
     Jg   Rtrim2
     Xor  AX,AX
     Mov  [DI],AL
     Dec  CX
     Dec  DI
     Cmp  CX,0
     Jge  Rtrim1
Rtrim2:
     Ret
     Rtrim$ Endp
     
     
     
     
     Ltrim$ Proc Near
     Mov  DI,Offset $_2_
     Call MoveStr
     Mov  SI,Offset $_2_
     Xor  CX,CX
Ltrim1:
     Cmp  [SI],Byte Ptr 32
     Jne  Ltrim2
     Inc  SI
     Inc  CX
     Cmp  CX,MaxString
     Jne  Ltrim1
Ltrim2:
     Mov  CX,MaxString
     Mov  DI,Offset $_1_
     Cld
     Rep  Movs Byte Ptr [DI],Byte Ptr ES:[SI]
     Ret
     Ltrim$ Endp
     
     
     
     
     ClrWork Proc Near
     Mov  DI,Offset $_0_
     Xor  AX,AX
     Mov  [DI],AX
     Ret
     ClrWork Endp
     
     
     
     
     Assign Proc Near
     Mov  SI,Offset $_0_
     Call MoveStr
     Ret
     Assign Endp
     
     
Code Ends


Data Segment

;***************** System Initialized Data *****************

$Xcur        DW 1
$Ycur        DW 1
$Attr        DW 7
$CrLf        DB 13,10,'$'
$CrLf2       DB 13,10,0
FgColor      DW 7
BgColor      DW 0
Err          DW 0
DefSeg       DW 0
$DataSeg     DW 0
$Empty       DB 0,0
$Var0        DW 0
$Var1        DW 0
$Var2        DW 0
$Var3        DW 0
Command$     DB 81 DUP(?)

;***************** Users Initialized Data *******************

MODE          DW  0

;*************** System Un-Initialized Data *****************

$_0_         DB  MaxString DUP(?)
$_1_         DB  MaxString DUP(?)
$_2_         DB  MaxString DUP(?)

;**************** Users Un-Initialized Data *****************

CMD$          DB  MaxString  DUP(?)
;************************************************************
Data Ends

End
