'---------------------------------------------------------------------------
'
'                       Console Direct Graphics
'                         By Randall L Glass
'                           CopyRight 2001
'
'---------------------------------------------------------------------------
$IF 0

    This program is free software; you can redistribute it and/OR modify
    it under the terms of the GNU General Public License AS published by
    the Free Software Foundation; either version 2 of the License, OR
    (AT your OPTION) ANY later version.

    This program is distributed IN the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  See the
    file copying FOR the GNU General Public License FOR more details.

    The Author can be contacted AT: rlglass@yahoo.com. OR:

    Randall L Glass
    RR1,Box 248B
    McLeansboro,IL
    62859

Under Windows NT/2000, this program can only be used under administrative
privileges. OR install through the administrative account. IN that CASE,
however,the ShutdownWinIo FUNCTION must NOT be called before the application
is terminated, since this FUNCTION removes the WinIo driver FROM the
system's registry.


DESCRIPTION

This is a PBCC demonstration program. It requires vesa 2.0 .
It is a combination of Windows 95 console and PBDOS and basm .

Window is very hard to learn. And PBCC is not close enought
to PBDOS. Especially in the graphics department.

Some might say you can't do direct graphics in windows console mode.
That you can't make pbcc work like pbdos.

This program is to prove them wrong.

Here is hoping that Powerbasic Corp will make PBCC more like PBDOS now.
Especcialy since they now know it can be done. No exucuses now.

Powerbasic Corp just think of all the pbcc compilers you could sell if you
just make PBCC more like PBDOS. 

This program provides the ability to draw directy to video memory IN vesa 2
mode.

It provides primitive line,circle and pset.

WITH some work it can provide a lot more pbdos like graphic routines.
-----------------------------------------------------------------------------
Included is winio driver and dll,and source code.

Need Help

IF Someone can modify winio so you can call dpmi, I would apprectiate it.
With the ability to directly call dpmi, we can call bios interrupt &H10 from
windows instead of dos.

$ENDIF


GLOBAL VideoAddress???
GLOBAL WIDE%, HIGH%

DEFINT A-Z

DECLARE FUNCTION MapPhysToLin SDECL LIB "WINIO.DLL" ALIAS "MapPhysToLin" (BYVAL PhysAddr AS LONG, BYVAL PhysSize AS LONG, BYREF PhysMemHandle???) AS LONG
DECLARE FUNCTION InitializeWinIo SDECL LIB "WINIO.DLL"  ALIAS "InitializeWinIo"() AS BYTE
DECLARE FUNCTION ShutdownWinIo SDECL LIB "WINIO.DLL"  ALIAS "ShutdownWinIo"() AS BYTE
DECLARE FUNCTION SetPhysLong SDECL Lib "WinIo.dll" ALIAS "SetPhysLong"(BYVAL PhysAddr AS LONG, BYVAL PhysVal AS LONG) AS BYTE
DECLARE SUB Sleep LIB "KERNEL32.DLL" ALIAS "Sleep" (BYVAL dwMilliseconds AS LONG)
DECLARE SUB Circle (xc%, yc%, r%, c%)
DECLARE SUB DrawLine (x%, y%, x2%, y2%, c%)
DECLARE SUB PSET(x%,y,c%)

FUNCTION PBMAIN () AS LONG
High% = 480
Wide% = 640
Mode$ = "257" 'VESA Mode 640 by 480

InitializeWinIo
VesaError% = SHELL("GETVESA.EXE " + Mode$)
IF VesaError% = 0 THEN FUNCTION = 0:EXIT FUNCTION

OPEN "Vesa.dat" FOR INPUT AS #1
INPUT# 1, PhysicalAdress&
INPUT# 1, AdressSize&
CLOSE #1
VideoAddress??? = MapPhysToLin(PhysicalAdress&, AdressSize&, PhysicalMemoryHandle???)
SHELL "SETVESA.EXE " + Mode$
DrawLine 0, 0, 200, 200, 128
CIRCLE 100,100,50,128
DO:LOOP UNTIL INKEY$ <> ""
SHELL "Text.exe

ShutdownWinIo
END FUNCTION


SUB Delay(BYVAL seconds AS SINGLE)

  Sleep CLNG(seconds * 1000)

END SUB

SUB Circle (xc%, yc%, r%, c%)
'_|_|_|   Bresenham Circle Drawing Algorithm
'_|_|_|   Adapted from BRESNHAM.C in Bob Stout's SNIPPETS.
   x% = 0: d% = 2 * (1 - r%): W% = 2 * WIDE% \ HIGH%
   WHILE r% >= 0
      CALL PSET(xc% + x%, yc% + r%, c%)
      CALL PSET(xc% + x%, yc% - r%, c%)
      CALL PSET(xc% - x%, yc% + r%, c%)
      CALL PSET(xc% - x%, yc% - r%, c%)
      IF (d% + r%) > 0 THEN r% = r% - 1: d% = d% - W% * r% - 1
      IF x% > d% THEN x% = x% + 1: d% = d% + 2 * x% + 1
   WEND
END SUB

SUB DrawLine (x%, y%, x2%, y2%, c%)
'_|_|_|   Bresenham Line Drawing Algorithm
'_|_|_|   Adapted from BRESNHAM.C in Bob Stout's SNIPPETS.
   i% = 0: steep% = 0: e% = 0
   IF (x2% - x%) > 0 THEN sx% = 1: ELSE sx% = -1
   dx% = ABS(x2% - x%)
   IF (y2% - y%) > 0 THEN sy% = 1:  ELSE sy% = -1
   dy% = ABS(y2% - y%)
   IF (dy% > dx%) THEN
      steep% = 1
      SWAP x%, y%
      SWAP dx%, dy%
      SWAP sx%, sy%
   END IF
   e% = 2 * dy% - dx%
   FOR i% = 0 TO dx% - 1
      IF steep% = 1 THEN CALL PSET(y%, x%, c%):  ELSE CALL PSET(x%, y%, c%)
      WHILE e% >= 0
         y% = y% + sy%: e% = e% - 2 * dx%
      WEND
      x% = x% + sx%: e% = e% + 2 * dy%
   NEXT
   CALL PSET(x2%, y2%, c%)
END SUB

SUB PSET(x%,y,c%)
Address??? = VideoAddress??? + Y% * Wide% + X%
POKE Address???,C%
END SUB


